#ifndef GL_H
#define GL_H
/* most basic type for data passing */
typedef union {
	uint32_t dw; /* double word */
	uint16_t w[2]; /* word */
	uint8_t b[4]; /* byte */
} input_t;
extern int8_t command_length[]  __attribute__ ((visibility ("hidden")));
extern void (*function_dispatcher[])(input_t *)
	 __attribute__ ((visibility ("hidden")));
extern uint16_t vtx __attribute__ ((visibility ("hidden")));
extern uint16_t vtxs __attribute__ ((visibility ("hidden")));
extern uint16_t vty __attribute__ ((visibility ("hidden")));
extern uint16_t vtxe __attribute__ ((visibility ("hidden")));
extern uint16_t vtye __attribute__ ((visibility ("hidden")));
/* image tranfer direction for functions put_image() */
/* and get_image(), 1 - to VRAM, 2 - from VRAM */
extern uint8_t image_transfer __attribute__ ((visibility ("hidden")));
/* video memory - 1 MB */
#define MAXX 1024
#define MAXY 512
#define MAXTEXTURES 64
extern uint16_t vram[MAXX][MAXY] __attribute__ ((visibility ("hidden")));
extern uint32_t gpu_status __attribute__ ((visibility ("hidden")));
/* do wywalenia: */
extern int check_status __attribute__ ((visibility ("hidden")));
extern int trcnt __attribute__ ((visibility ("hidden")));
void
GPUupdateLace(void);
void
print_matrices(void);
#endif
